

format MS COFF

public EXPORTS

;;;=======================
;;; strcpy
;;;=======================

align 4

_strcpy:
	push	ebp
	mov	ebp, esp
	add	esp, -4
	lea	eax, [ebp-4]
	push	eax
	lea	eax, [ebp+12]
	mov	ebx, eax
	mov	eax, [ebx]
	pop	ebx
	mov	[ebx], eax
_lib_7:
	lea	eax, [ebp+12]
	mov	ebx, eax
	mov	eax, [ebx]
	inc	eax
	mov	[ebx], eax
	dec	eax
	push	eax
	lea	eax, [ebp+8]
	mov	ebx, eax
	mov	eax, [ebx]
	inc	eax
	mov	[ebx], eax
	dec	eax
	mov	ebx, eax
	movsx	eax, byte [ebx]
	pop	ebx
	mov	[ebx], al
	or	eax, eax
	jne	_lib_9
	jmp	_lib_8
_lib_9:
	jmp	_lib_7
_lib_8:
	lea	eax, [ebp-4]
	mov	ebx, eax
	mov	eax, [ebx]
	mov	esp, ebp
	pop	ebp
	ret

;;;=======================
;;; strlen
;;;=======================

align 4

_strlen:
	push	ebp
	mov	ebp, esp
	add	esp, -4
	lea	eax, [ebp-4]
	push	eax
	lea	eax, [ebp+8]
	mov	ebx, eax
	mov	eax, [ebx]
	pop	ebx
	mov	[ebx], eax
_lib_11:
	lea	eax, [ebp-4]
	mov	ebx,eax
	mov	eax, [ebx]
	mov	ebx, eax
	movsx	eax, byte [ebx]
	or	eax,eax
	jne	_lib_13
	jmp	_lib_12
_lib_13:
	lea	eax, [ebp-4]
	mov	ebx, eax
	mov	eax, [ebx]
	inc	eax
	mov	[ebx], eax
	jmp	_lib_11
_lib_12:
	lea	eax, [ebp-4]
	mov	ebx, eax
	mov	eax, [ebx]
	push	eax
	lea	eax, [ebp+8]
	mov	ebx, eax
	mov	eax, [ebx]
	pop	ebx
	xchg	eax, ebx
	sub	eax, ebx
	mov	esp, ebp
	pop	ebp
	ret

;;;=======================
;;; strcmp
;;;=======================

align 4

_strcmp:
	push	ebp
	mov	ebp, esp
	add	esp, -4
L2:
	mov	eax, [ebp+8]
	mov	edx, [ebp+12]
	mov	al, [eax]
	cmp	al, [edx]
	jge	L5
	mov	dword [ebp-4], -1
	jmp	L1
L5:
	mov	eax, [ebp+8]
	mov	edx, [ebp+12]
	mov	al, [eax]
	cmp	al, [edx]
	jle	L6
	mov	dword [ebp-4], 1
	jmp	L1
L6:
	mov	eax, [ebp+8]
	cmp	byte [eax], 0
	jne	L7
	mov	dword [ebp-4], 0
	jmp	L1
L7:
	inc	dword [ebp+8]
	lea	eax, [ebp+12]
	inc	dword [eax]
	jmp	L2
L1:
	mov	eax, [ebp-4]
	leave
	ret


;;;=======================
;;; EXPORTS
;;;=======================

align 4
EXPORTS:

	dd      sz_strcmp, _strcmp
	dd      sz_strcpy, _strcpy
	dd      sz_strlen, _strlen
	dd	0, 0

sz_strcmp	db 'strcmp',0
sz_strcpy	db 'strcpy',0
sz_strlen	db 'strlen',0
